# This file contains S10 HPS EMIF configuration and export of signals/ports
# Tentatively, planned support to S10 SoC Devkit and S10 PE board revC
# DDR4 is currently planned for both boards stated above, DDR3 is also supported on the devkit.
# This file will be source by GHRD create qsys tcl
# source ./arguments_solver.tcl
# source ./s10_hps_parameter_solver.tcl
source ./utils.tcl

if {$hps_emif_en == 1} {
set total_hps_emif_width $hps_emif_width
if {$hps_emif_ecc_en} {
   incr total_hps_emif_width 8
}
}
if {$fpga_emif_en == 1} {
set total_fpga_emif_width $fpga_emif_width
if {$fpga_emif_ecc_en} {
   incr total_fpga_emif_width 8
}
}

if {$board == "devkit"} {
# ------ Component configuration --------------------- #

# note: you may apply preset then modify or directly set intended value of whole component's parameters
# sample of instantiation could be something like following
   if {$hps_emif_en == 1} {

      add_component_param     "altera_emif_s10_hps emif_hps 
							   IP_FILE_PATH ip/$qsys_name/emif_hps.ip"
							   

      if {$hps_emif_type == "ddr4"} {
         load_component emif_hps
         apply_component_preset  "DDR4-2400U CL18 Component 1CS 4Gb (256Mb x16)"
         save_component
    
         set_component_param     "emif_hps PROTOCOL_ENUM PROTOCOL_DDR4"
         set_component_param     "emif_hps PHY_DDR4_RATE_ENUM RATE_HALF"
         set_component_param     "emif_hps MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
         set_component_param     "emif_hps MEM_DDR4_DQ_WIDTH $total_hps_emif_width"
         set_component_param     "emif_hps MEM_DDR4_TCL 18"
         set_component_param     "emif_hps MEM_DDR4_WTCL 16"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_DATA_LANES"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_DQS_GROUP 0"
         set_component_param     "emif_hps MEM_DDR4_NUM_OF_DIMMS 1"
         set_component_param     "emif_hps MEM_DDR4_RANKS_PER_DIMM 1"
         set_component_param     "emif_hps MEM_DDR4_CK_WIDTH 1"
         set_component_param     "emif_hps MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_ODT_DISABLED"
         set_component_param     "emif_hps MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
         set_component_param     "emif_hps MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_RZQ_4"
         set_component_param     "emif_hps MEM_DDR4_DM_EN true"
         set_component_param     "emif_hps MEM_DDR4_READ_DBI true"
         set_component_param     "emif_hps MEM_DDR4_WRITE_DBI false"
         set_component_param     "emif_hps PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
         set_component_param     "emif_hps PHY_DDR4_USER_PING_PONG_EN false"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
         set_component_param     "emif_hps PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
         set_component_param     "emif_hps CTRL_DDR4_ECC_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps CTRL_DDR4_ECC_AUTO_CORRECTION_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_IO false"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
         set_component_param     "emif_hps PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
         set_component_param     "emif_hps PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"
         set_component_param     "emif_hps DIAG_EXTRA_CONFIGS SEQ_DBG_SKIP_STEPS_ADD=245760"
      } elseif {$hps_emif_type == "ddr3"} {
         load_component emif_hps
         apply_component_preset  "DDR3-2133N CL14 Component 1CS 4Gb (256Mb x16)"
         save_component

         set_component_param     "emif_hps  PROTOCOL_ENUM PROTOCOL_DDR3"
         set_component_param     "emif_hps  PHY_DDR3_RATE_ENUM RATE_HALF"
         set_component_param     "emif_hps  MEM_DDR3_FORMAT_ENUM MEM_FORMAT_UDIMM"
         set_component_param     "emif_hps  MEM_DDR3_DQ_WIDTH $total_hps_emif_width"
         set_component_param     "emif_hps  MEM_DDR3_TCL 14"
         set_component_param     "emif_hps  MEM_DDR3_WTCL 10"
         set_component_param     "emif_hps  MEM_DDR3_NUM_OF_DIMMS 1"
         set_component_param     "emif_hps  MEM_DDR3_RANKS_PER_DIMM 1"
         set_component_param     "emif_hps  MEM_DDR3_CK_WIDTH 1"
         set_component_param     "emif_hps  MEM_DDR3_RTT_WR_ENUM DDR3_RTT_WR_RZQ_4"
         set_component_param     "emif_hps  MEM_DDR3_DRV_STR_ENUM DDR3_DRV_STR_RZQ_7"
         set_component_param     "emif_hps  MEM_DDR3_RTT_NOM_ENUM DDR3_RTT_NOM_ODT_DISABLED"
         set_component_param     "emif_hps  MEM_DDR3_DM_EN true"
         set_component_param     "emif_hps  PHY_DDR3_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
         set_component_param     "emif_hps  PHY_DDR3_USER_PING_PONG_EN false"
         set_component_param     "emif_hps  PHY_DDR3_USER_REF_CLK_FREQ_MHZ 133.333"
         set_component_param     "emif_hps  PHY_DDR3_DEFAULT_REF_CLK_FREQ false"
         set_component_param     "emif_hps  CTRL_DDR3_ECC_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps  CTRL_DDR3_ECC_AUTO_CORRECTION_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps  PHY_DDR3_IO_VOLTAGE 1.5"
         set_component_param     "emif_hps  PHY_DDR3_DEFAULT_IO false"
         set_component_param     "emif_hps  PHY_DDR3_USER_AC_IO_STD_ENUM IO_STD_SSTL_15_C1"
         set_component_param     "emif_hps  PHY_DDR3_USER_CK_IO_STD_ENUM IO_STD_SSTL_15_C1"
         set_component_param     "emif_hps  PHY_DDR3_USER_DATA_IO_STD_ENUM IO_STD_SSTL_15"
         set_component_param     "emif_hps  PHY_DDR3_USER_AC_MODE_ENUM CURRENT_ST_8"
         set_component_param     "emif_hps  PHY_DDR3_USER_CK_MODE_ENUM CURRENT_ST_8"
         set_component_param     "emif_hps  PHY_DDR3_USER_DATA_OUT_MODE_ENUM OUT_OCT_34_CAL"
         set_component_param     "emif_hps  PHY_DDR3_USER_DATA_IN_MODE_ENUM IN_OCT_120_CAL"
         set_component_param     "emif_hps  PHY_DDR3_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
         set_component_param     "emif_hps  PHY_DDR3_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_15"
         set_component_param     "emif_hps  PHY_DDR3_MEM_CLK_FREQ_MHZ 1066.667"
      }


      # ------ Connections --------------------------------- #
      connect "emif_hps.hps_emif ${cpu_instance}.hps_emif"

      # ------ Ports export -------------------------------- #
      export emif_hps mem         emif_hps_mem 
      export emif_hps oct         emif_hps_oct 
      export emif_hps pll_ref_clk emif_hps_pll_ref_clk 
   }

   if {$fpga_emif_en == 1} {
      add_component_param     "altera_emif_s10 fpga_emif
							   IP_FILE_PATH ip/$qsys_name/fpga_emif.ip"

      load_component emif_hps
      apply_component_preset  fpga_emif "DDR4-2400U CL18 Component 1CS 4Gb (256Mb x16)"
      save_component
  
      set_component_param     "fpga_emif PROTOCOL_ENUM PROTOCOL_DDR4"
      set_component_param     "fpga_emif PHY_DDR4_RATE_ENUM RATE_HALF"
      set_component_param     "fpga_emif MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
      set_component_param     "fpga_emif MEM_DDR4_DQ_WIDTH $total_fpga_emif_width"
      set_component_param     "fpga_emif MEM_DDR4_TCL 18"
      set_component_param     "fpga_emif MEM_DDR4_WTCL 16"
      set_component_param     "fpga_emif MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_DATA_LANES"
      set_component_param     "fpga_emif MEM_DDR4_ALERT_N_DQS_GROUP 0"
      set_component_param     "fpga_emif MEM_DDR4_NUM_OF_DIMMS 1"
      set_component_param     "fpga_emif MEM_DDR4_RANKS_PER_DIMM 1"
      set_component_param     "fpga_emif MEM_DDR4_CK_WIDTH 1"
      set_component_param     "fpga_emif MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_ODT_DISABLED"
      set_component_param     "fpga_emif MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
      set_component_param     "fpga_emif MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_RZQ_4"
      set_component_param     "fpga_emif MEM_DDR4_DM_EN true"
      set_component_param     "fpga_emif MEM_DDR4_READ_DBI true"
      set_component_param     "fpga_emif MEM_DDR4_WRITE_DBI false"
      set_component_param     "fpga_emif PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
      set_component_param     "fpga_emif PHY_DDR4_USER_PING_PONG_EN false"
      set_component_param     "fpga_emif PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
      set_component_param     "fpga_emif PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
      set_component_param     "fpga_emif CTRL_DDR4_ECC_EN $fpga_emif_ecc_en"
      set_component_param     "fpga_emif CTRL_DDR4_ECC_AUTO_CORRECTION_EN $fpga_emif_ecc_en"
      set_component_param     "fpga_emif PHY_DDR4_DEFAULT_IO false"
      set_component_param     "fpga_emif PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
      set_component_param     "fpga_emif PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
      set_component_param     "fpga_emif PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
      set_component_param     "fpga_emif PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
      set_component_param     "fpga_emif PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
      set_component_param     "fpga_emif PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_40_CAL"
      set_component_param     "fpga_emif PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
      set_component_param     "fpga_emif PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
      set_component_param     "fpga_emif PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
      set_component_param     "fpga_emif PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"
      set_component_param     "fpga_emif DIAG_EXTRA_CONFIGS SEQ_DBG_SKIP_STEPS_ADD=245760,DIAG_DISABLE_USERMODE_OCT_WORKAROUND=true"
     
      # ------ Connections --------------------------------- #
      connect "rst_in.out_reset fpga_emif.global_reset_reset_sink"
## This is for the SODIMM interface      load_component fpga_emif
## This is for the SODIMM interface      apply_component_preset"DDR4-2400U CL18 Component 1CS 8Gb (1Gb x8)"
## This is for the SODIMM interface      save_component
## This is for the SODIMM interface      set_component_param   "fpga_emif PROTOCOL_ENUM PROTOCOL_DDR4"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_RATE_ENUM RATE_QUARTER"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_DQ_WIDTH 8"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_TCL 17"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_WTCL 16"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_AC_LANES"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_ALERT_N_AC_LANE 3"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_ALERT_N_AC_PIN 7"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_NUM_OF_DIMMS 1"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_RANKS_PER_DIMM 2"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_CK_WIDTH 2"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_RZQ_3"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_ODT_DISABLED"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_RTT_PARK DDR4_RTT_PARK_ODT_DISABLED"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_USE_DEFAULT_ODT 'false'"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_R_ODT0_1X1 off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_W_ODT0_1X1 off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_R_ODT0_2X2 off,off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_R_ODT1_2X2 off,off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_W_ODT0_2X2 off,off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_W_ODT1_2X2 off,off"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_DM_EN true"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_READ_DBI true"
## This is for the SODIMM interface      set_component_param   "fpga_emif MEM_DDR4_WRITE_DBI false"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
## This is for the SODIMM interface      set_component_param   "fpga_emif CTRL_DDR4_ECC_EN false"
## This is for the SODIMM interface      set_component_param   "fpga_emif CTRL_DDR4_ECC_AUTO_CORRECTION_EN false"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_DEFAULT_IO false"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_34_CAL"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
## This is for the SODIMM interface      set_component_param   "fpga_emif DIAG_DDR4_EXPORT_SEQ_AVALON_SLAVE CAL_DEBUG_EXPORT_MODE_JTAG"
## This is for the SODIMM interface      set_component_param   "fpga_emif PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"
## This is for the SODIMM interface      set_component_param   "fpga_emif DIAG_DDR4_SKIP_CA_DESKEW true"

      # ------ Ports export -------------------------------- #
      export fpga_emif local_reset_req       fpga_emif_local_reset_req 
      export fpga_emif local_reset_status    fpga_emif_local_reset_status 
      if {$fpga_emif_ecc_en == 1} {
      export fpga_emif ctrl_ecc_user_interrupt_0   fpga_emif_ctrl_ecc_user_interrupt 
      }
      export fpga_emif status                fpga_emif_status 
      export fpga_emif mem                   fpga_emif_mem 
      export fpga_emif oct                   fpga_emif_oct 
      export fpga_emif pll_ref_clk           fpga_emif_pll_ref_clk 
   }

} elseif {$board == "pe"} {
   # ------ Component configuration --------------------- #
   add_component_param     "altera_emif_s10_hps emif_hps
							   IP_FILE_PATH ip/$qsys_name/emif_hps.ip"

   load_component emif_hps
   apply_component_preset  "DDR4-2666V CL20 Component 1CS 8Gb (1Gb x8)"
   save_component
   
   set_component_param     "emif_hps PROTOCOL_ENUM PROTOCOL_DDR4"
   set_component_param     "emif_hps PHY_DDR4_RATE_ENUM RATE_HALF"
   set_component_param     "emif_hps MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
   set_component_param     "emif_hps MEM_DDR4_DQ_WIDTH $total_hps_emif_width"
   set_component_param     "emif_hps MEM_DDR4_TCL 16"
   set_component_param     "emif_hps MEM_DDR4_WTCL 14"
   set_component_param     "emif_hps MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_DATA_LANES"
   set_component_param     "emif_hps MEM_DDR4_ALERT_N_DQS_GROUP 0"
   set_component_param     "emif_hps MEM_DDR4_NUM_OF_DIMMS 1"
   set_component_param     "emif_hps MEM_DDR4_RANKS_PER_DIMM 1"
   set_component_param     "emif_hps MEM_DDR4_CK_WIDTH 1"
   set_component_param     "emif_hps MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_ODT_DISABLED"
   set_component_param     "emif_hps MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
   set_component_param     "emif_hps MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_RZQ_4"
   set_component_param     "emif_hps MEM_DDR4_DM_EN true"
   set_component_param     "emif_hps MEM_DDR4_READ_DBI true"
   set_component_param     "emif_hps MEM_DDR4_WRITE_DBI false"
   set_component_param     "emif_hps PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
   set_component_param     "emif_hps PHY_DDR4_USER_PING_PONG_EN false"
   set_component_param     "emif_hps PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
   set_component_param     "emif_hps PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
   set_component_param     "emif_hps CTRL_DDR4_ECC_EN $hps_emif_ecc_en"
   set_component_param     "emif_hps CTRL_DDR4_ECC_AUTO_CORRECTION_EN $hps_emif_ecc_en"
   set_component_param     "emif_hps PHY_DDR4_DEFAULT_IO false"
   set_component_param     "emif_hps PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
   set_component_param     "emif_hps PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
   set_component_param     "emif_hps PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
   set_component_param     "emif_hps PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
   set_component_param     "emif_hps PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
   set_component_param     "emif_hps PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_40_CAL"
   set_component_param     "emif_hps PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
   set_component_param     "emif_hps PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_CMOS_12"
   set_component_param     "emif_hps PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
   set_component_param     "emif_hps PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"

   # ------ Connections --------------------------------- #
   connect "emif_hps.hps_emif ${cpu_instance}.hps_emif"

   # ------ Ports export -------------------------------- #
   export emif_hps mem         emif_hps_mem 
   export emif_hps oct         emif_hps_oct 
   export emif_hps pll_ref_clk emif_hps_pll_ref_clk 
} elseif {$board == "atso12" } {
# ------ Component configuration --------------------- #

# note: you may apply preset then modify or directly set intended value of whole component's parameters
# sample of instantiation could be something like following
   if {$hps_emif_en == 1} {

      add_component_param     "altera_emif_s10_hps emif_hps 
							   IP_FILE_PATH ip/$qsys_name/emif_hps.ip"
							   

      if {$hps_emif_type == "ddr4"} {
         load_component emif_hps
         apply_component_preset  "DDR4-2400U CL18 Component 1CS 4Gb (256Mb x16)"
         save_component
    
         set_component_param     "emif_hps PROTOCOL_ENUM PROTOCOL_DDR4"
         set_component_param     "emif_hps PHY_DDR4_RATE_ENUM RATE_HALF"
         set_component_param     "emif_hps MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
         set_component_param     "emif_hps MEM_DDR4_DQ_WIDTH $total_hps_emif_width"
         set_component_param     "emif_hps MEM_DDR4_TCL 18"
         set_component_param     "emif_hps MEM_DDR4_WTCL 16"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_DATA_LANES"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_DQS_GROUP 0"
         set_component_param     "emif_hps MEM_DDR4_NUM_OF_DIMMS 1"
         set_component_param     "emif_hps MEM_DDR4_RANKS_PER_DIMM 1"
         set_component_param     "emif_hps MEM_DDR4_CK_WIDTH 1"
         set_component_param     "emif_hps MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_ODT_DISABLED"
         set_component_param     "emif_hps MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
         set_component_param     "emif_hps MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_RZQ_4"
         set_component_param     "emif_hps MEM_DDR4_DM_EN true"
         set_component_param     "emif_hps MEM_DDR4_READ_DBI true"
         set_component_param     "emif_hps MEM_DDR4_WRITE_DBI false"
         set_component_param     "emif_hps PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
         set_component_param     "emif_hps PHY_DDR4_USER_PING_PONG_EN false"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
         set_component_param     "emif_hps PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
         set_component_param     "emif_hps CTRL_DDR4_ECC_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps CTRL_DDR4_ECC_AUTO_CORRECTION_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_IO false"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
         set_component_param     "emif_hps PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
         set_component_param     "emif_hps PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"
         set_component_param     "emif_hps DIAG_EXTRA_CONFIGS SEQ_DBG_SKIP_STEPS_ADD=245760"
      } 

      # ------ Connections --------------------------------- #
      connect "emif_hps.hps_emif ${cpu_instance}.hps_emif"

      # ------ Ports export -------------------------------- #
      export emif_hps mem         emif_hps_mem 
      export emif_hps oct         emif_hps_oct 
      export emif_hps pll_ref_clk emif_hps_pll_ref_clk 
   }
} elseif {$board == "ashfield"} {
# ------ Component configuration --------------------- #

# note: you may apply preset then modify or directly set intended value of whole component's parameters
# sample of instantiation could be something like following
   if {$hps_emif_en == 1} {

      add_component_param     "altera_emif_s10_hps emif_hps 
							   IP_FILE_PATH ip/$qsys_name/emif_hps.ip"
							   

      if {$hps_emif_type == "ddr4"} {
         load_component emif_hps
         apply_component_preset  "DDR4-2400U CL18 Component 1CS 4Gb (256Mb x16)"
         save_component
    
         set_component_param     "emif_hps PROTOCOL_ENUM PROTOCOL_DDR4"
         set_component_param     "emif_hps PHY_DDR4_RATE_ENUM RATE_HALF"
         set_component_param     "emif_hps MEM_DDR4_FORMAT_ENUM MEM_FORMAT_UDIMM"
         set_component_param     "emif_hps MEM_DDR4_DQ_WIDTH $total_hps_emif_width"
         set_component_param     "emif_hps MEM_DDR4_TCL 18"
         set_component_param     "emif_hps MEM_DDR4_WTCL 16"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_PLACEMENT_ENUM DDR4_ALERT_N_PLACEMENT_DATA_LANES"
         set_component_param     "emif_hps MEM_DDR4_ALERT_N_DQS_GROUP 4"
         set_component_param     "emif_hps MEM_DDR4_NUM_OF_DIMMS 1"
         set_component_param     "emif_hps MEM_DDR4_RANKS_PER_DIMM 1"
         set_component_param     "emif_hps MEM_DDR4_CK_WIDTH 1"
         set_component_param     "emif_hps MEM_DDR4_RTT_WR_ENUM DDR4_RTT_WR_ODT_DISABLED"
         set_component_param     "emif_hps MEM_DDR4_DRV_STR_ENUM DDR4_DRV_STR_RZQ_7"
         set_component_param     "emif_hps MEM_DDR4_RTT_NOM_ENUM DDR4_RTT_NOM_RZQ_4"
         set_component_param     "emif_hps MEM_DDR4_DM_EN true"
         set_component_param     "emif_hps MEM_DDR4_READ_DBI true"
         set_component_param     "emif_hps MEM_DDR4_WRITE_DBI false"
         set_component_param     "emif_hps PHY_DDR4_CONFIG_ENUM CONFIG_PHY_AND_HARD_CTRL"
         set_component_param     "emif_hps PHY_DDR4_USER_PING_PONG_EN false"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_REF_CLK_FREQ false"
         set_component_param     "emif_hps PHY_DDR4_USER_REF_CLK_FREQ_MHZ 133.333"
         set_component_param     "emif_hps CTRL_DDR4_ECC_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps CTRL_DDR4_ECC_AUTO_CORRECTION_EN $hps_emif_ecc_en"
         set_component_param     "emif_hps PHY_DDR4_DEFAULT_IO false"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_IO_STD_ENUM IO_STD_SSTL_12"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IO_STD_ENUM IO_STD_POD_12"
         set_component_param     "emif_hps PHY_DDR4_USER_AC_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_CK_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_OUT_MODE_ENUM OUT_OCT_40_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_DATA_IN_MODE_ENUM IN_OCT_60_CAL"
         set_component_param     "emif_hps PHY_DDR4_USER_PLL_REF_CLK_IO_STD_ENUM IO_STD_LVDS"
         set_component_param     "emif_hps PHY_DDR4_USER_RZQ_IO_STD_ENUM IO_STD_CMOS_12"
         set_component_param     "emif_hps PHY_DDR4_MEM_CLK_FREQ_MHZ 1066.667"
         set_component_param     "emif_hps DIAG_EXTRA_CONFIGS SEQ_DBG_SKIP_STEPS_ADD=245760"
      } 

      # ------ Connections --------------------------------- #
      connect "emif_hps.hps_emif ${cpu_instance}.hps_emif"

      # ------ Ports export -------------------------------- #
      export emif_hps mem         emif_hps_mem 
      export emif_hps oct         emif_hps_oct 
      export emif_hps pll_ref_clk emif_hps_pll_ref_clk 
   }
}
