#This file define the location, io standard, current drive strength, signal width, and signal direction settings for every port available on the FPGA side in the design.

#define all the location assignments in sequence for specific port data with signal width more than one
# set fpga_led_pio_pin_list {
# H21
# J21
# L19
# K19
# }

# set fpga_dipsw_pio_pin_list {
# N21
# P21
# N20
# P20
# }

# set fpga_button_pio_pin_list {
# BG17
# BE17
# BH18
# BJ19
# }

# set fpga_led_pio_qsys_exported_port_list {
# led_pio_external_connection_in_port
# led_pio_external_connection_out_port
# }

#TBD: need to update with correct pin assignments according to PE board
dict set pin_assignment_table fpga_clk_100 location AV10
dict set pin_assignment_table fpga_clk_100 io_standard "LVDS"
dict set pin_assignment_table fpga_clk_100 direction input
dict set pin_assignment_table fpga_clk_100 width_in_bits 1
dict set pin_assignment_table fpga_clk_100 qsys_exported_port "clk_100_clk"

dict set pin_assignment_table fpga_reset_n location H21
dict set pin_assignment_table fpga_reset_n io_standard "1.8 V"
dict set pin_assignment_table fpga_reset_n direction input
dict set pin_assignment_table fpga_reset_n width 1
dict set pin_assignment_table fpga_reset_n qsys_exported_port "reset_reset_n"

# dict set pin_assignment_table fpga_led_pio location $fpga_led_pio_pin_list
# dict set pin_assignment_table fpga_led_pio io_standard "1.8 V"
# dict set pin_assignment_table fpga_led_pio direction output
# dict set pin_assignment_table fpga_led_pio width_in_bits 4
# dict set pin_assignment_table fpga_led_pio qsys_exported_port $fpga_led_pio_qsys_exported_port_list

# dict set pin_assignment_table fpga_dipsw_pio location $fpga_dipsw_pio_pin_list
# dict set pin_assignment_table fpga_dipsw_pio io_standard "1.8 V"
# dict set pin_assignment_table fpga_dipsw_pio direction input
# dict set pin_assignment_table fpga_dipsw_pio width_in_bits 4
# dict set pin_assignment_table fpga_dipsw_pio qsys_exported_port "dipsw_pio_external_connection_export"

# dict set pin_assignment_table fpga_button_pio location $fpga_button_pio_pin_list
# dict set pin_assignment_table fpga_button_pio io_standard "1.8 V"
# dict set pin_assignment_table fpga_button_pio direction input
# dict set pin_assignment_table fpga_button_pio width_in_bits 4
# dict set pin_assignment_table fpga_button_pio qsys_exported_port "button_pio_external_connection_export"



puts "Number of ports: [dict size $pin_assignment_table]"